//+------------------------------------------------------------------+
//|                MuppetMan MA MACD.mq4                             |
//|                Copyright  2006  Scorpion@fxfisherman.com        |
//+------------------------------------------------------------------+
#property copyright "FxFisherman.com"
#property link      "http://www.fxfisherman.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 Blue
#property indicator_color4 Red

extern int MA1_Period = 10;
 int MA1_Type = 3;
extern int MA2_Period = 20;
 int MA2_Type = 0;
extern int MACD_Fast = 24;
extern int MACD_Slow = 52;
extern int MACD_Slowing = 18; 
extern int Shift_Bars=0;
extern int Bars_Count= 20000;

//---- buffers
double v1[];
double v2[];
double v3[];
double v4[];
  
int init()
  {

   IndicatorBuffers(4);
   SetIndexArrow(0,217);
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,1);
   SetIndexDrawBegin(0,-1);
   SetIndexBuffer(0, v1);
   SetIndexLabel(0,"Buy");
   
   SetIndexArrow(1,218);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,1);
   SetIndexDrawBegin(1,-1);
   SetIndexBuffer(1, v2);
   SetIndexLabel(1,"Sell");
   
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexDrawBegin(2,-1);
   SetIndexBuffer(2, v3);
   SetIndexLabel(2,"MA1");
   
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
   SetIndexDrawBegin(3,-1);
   SetIndexBuffer(3, v4);
   SetIndexLabel(3,"MA2");
   
   
   watermark();
 
   return(0);
  }

int start()
 {
  double ma1, ma2, macd, macd_sig;
  int previous;
  int i;
  int shift;
  bool crossed_up, crossed_down;
  int counted_bars = IndicatorCounted();
  if (counted_bars > 0) counted_bars--;
  if (Bars_Count > 0 && Bars_Count <= Bars)
  {
    i = Bars_Count - counted_bars;
  }else{
    i = Bars - counted_bars;
  }
  
  while(i>=0)
   {
    shift = i + Shift_Bars;
    ma1 = iMA(Symbol(), Period(), MA1_Period, 0, MA1_Type, PRICE_CLOSE, shift+1);
    ma2 = iMA(Symbol(), Period(), MA2_Period, 0, MA2_Type, PRICE_CLOSE, shift+1);
    macd = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow, MACD_Slowing, PRICE_CLOSE, MODE_MAIN, shift+1);
    macd_sig = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow, MACD_Slowing, PRICE_CLOSE, MODE_SIGNAL, shift+1);
    crossed_up = (ma1 > ma2 && macd > macd_sig);
    crossed_down = (ma1 < ma2 && macd < macd_sig);
    
    v3[i] = ma1;
    v4[i] = ma2;
    if (crossed_up && previous != 1) {
      v1[i] = Open[shift];
      previous = 1;
    }else if(crossed_down && previous != 2){
      v2[i] = Open[shift];
      previous = 2;
    }
    
    i--;
   }   
  return(0);
 }
 
//+------------------------------------------------------------------+

void watermark()
  {
   ObjectCreate("fxfisherman", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("fxfisherman", "fxfisherman.com", 11, "Lucida Handwriting", RoyalBlue);
   ObjectSet("fxfisherman", OBJPROP_CORNER, 2);
   ObjectSet("fxfisherman", OBJPROP_XDISTANCE, 5);
   ObjectSet("fxfisherman", OBJPROP_YDISTANCE, 10);
   return(0);
  }